#ifndef FLYDIRDIALOG_H
#define FLYDIRDIALOG_H

#include <QObject>

#include "idirdialog.h"
#include "flyfiledialog_global.h"

class FLY_FILEDIALOG_EXPORT FlyDirDialog : public QObject, LibFlyFileDialog::IDirDialog
{
    Q_OBJECT
public:
    explicit FlyDirDialog(QWidget *parent = nullptr,
                          const QString &caption = QString(),
                          const QString &directory = QString());

    ~FlyDirDialog();

    void setDirectory(const QString &directory) override;
    QString directory() const override;

    QStringList selectedDirs() const override;

    void setSidebarUrls(const QList<QUrl> & urls) override;
    QList<QUrl> sidebarUrls() const override;

    void setVisible(bool visible) override;

    void setShowOptions(Qt::WindowFlags windowFlags,
                        Qt::WindowModality windowModality,
                        QWindow *parent) override;

    QString windowTitle() const override;

    QObject *signalsObject() const override;

    static bool isExternal();

public Q_SLOTS:
    void setWindowTitle(const QString &) override;
    int exec() override;

Q_SIGNALS:
    void currentUrlChanged(const QUrl & url);
    void directoryUrlEntered(const QUrl & directory);
    void urlSelected(const QUrl & url);
    void urlsSelected(const QList<QUrl> & urls);
    void filterSelected(const QString & filter);
    void accepted();
    void rejected();

private:
    static LibFlyFileDialog::IDirDialog* createDirDialog(QWidget *parent = nullptr);
    LibFlyFileDialog::IDirDialog* dirDialog;
};

#endif // FLYDIRDIALOG_H
