#ifndef IDIRDIALOG_H
#define IDIRDIALOG_H

#include <QFileDialog>

namespace LibFlyFileDialog
{
class IDirDialog
{
public:
    virtual ~IDirDialog() {}

    virtual void setDirectory(const QString &directory) = 0;
    virtual QString directory() const = 0;

    virtual QStringList selectedDirs() const = 0;

    virtual void setSidebarUrls(const QList<QUrl> & urls) = 0;
    virtual QList<QUrl> sidebarUrls() const = 0;

    virtual void setVisible(bool visible) = 0;

    virtual void setShowOptions(Qt::WindowFlags windowFlags,
                                Qt::WindowModality windowModality,
                                QWindow *parent) = 0;

    virtual QString windowTitle() const = 0;
    virtual void setWindowTitle(const QString &) = 0;

    virtual int exec() = 0;

    virtual QObject *signalsObject() const { return Q_NULLPTR; }
};
}

#endif
