#ifndef IEXTRACONTROLS_H
#define IEXTRACONTROLS_H

#include <QtCore/QObject>
#include <QtCore/QString>

namespace LibFlyFileDialog
{
class IExtraControls
{
public:
    virtual ~IExtraControls() {}

    virtual bool supportsExtraControls() const = 0;

    virtual void setControlEnabled(int id, bool on) = 0;
    virtual void setControlVisible(int id, bool on) = 0;
    virtual void setControlText(int id, const QString &text) = 0;
    virtual QString controlText(int id) const = 0;

    virtual void addCheckBox(int id, const QString &text) = 0;
    virtual void setCheckBoxChecked(int id, bool on) = 0;
    virtual bool isCheckBoxChecked(int id) const = 0;

    virtual void addComboBox(int id, const QString &text) = 0;
    virtual void addComboBoxItem(int id, const QString &item) = 0;
    virtual void removeComboBoxItem(int id, int idx) = 0;
    virtual void setCurrentComboBoxItem(int id, int idx) = 0;
    virtual int currentComboBoxItem(int id) = 0;
};
}

#define IExtraControls_iid "ru.astralinux.IExtraControls/1.0"
Q_DECLARE_INTERFACE(LibFlyFileDialog::IExtraControls, IExtraControls_iid)

#endif
