#ifndef IFILEDIALOG_H
#define IFILEDIALOG_H

#include <QFileDialog>

namespace LibFlyFileDialog
{
class IFileDialog
{
public:
    virtual ~IFileDialog() {}

    virtual void setDirectory(const QString &directory) = 0;
    virtual QString directory() const = 0;

    virtual void selectFile(const QString &filename) = 0;
    virtual QStringList selectedFiles() const = 0;

    virtual void setNameFilter(const QString &filter) = 0;
    virtual void setNameFilters(const QStringList& filters) = 0;
    virtual void selectNameFilter(const QString &filter) = 0;
    virtual QString selectedNameFilter() const = 0;

    virtual QDir::Filters filter() const = 0;
    virtual void setFilter(QDir::Filters filters) = 0;

    virtual void setViewMode(QFileDialog::ViewMode mode) = 0;
    virtual QFileDialog::ViewMode viewMode() const = 0;

    virtual void setFileMode(QFileDialog::FileMode mode) = 0;
    virtual QFileDialog::FileMode fileMode() const = 0;

    virtual void setAcceptMode(QFileDialog::AcceptMode mode) = 0;
    virtual QFileDialog::AcceptMode acceptMode() const = 0;

    virtual void setConfirmOverwrite(bool enabled) = 0;
    virtual bool confirmOverwrite() const = 0;

    virtual void setDefaultSuffix(const QString &suffix) = 0;
    virtual QString defaultSuffix() const = 0;

    virtual void setSidebarUrls(const QList<QUrl> & urls) = 0;
    virtual QList<QUrl> sidebarUrls() const = 0;

    virtual void setVisible(bool visible) = 0;

    virtual void setShowOptions(Qt::WindowFlags windowFlags,
                                Qt::WindowModality windowModality,
                                QWindow *parent) = 0;

    virtual QString windowTitle() const = 0;
    virtual void setWindowTitle(const QString &) = 0;

    virtual int exec() = 0;

    virtual QObject *signalsObject() const { return Q_NULLPTR; }
};
}

#endif
